from typing import Optional

from cpl_core.console import Console

from py_to_uxf_core.abc.class_scanner_abc import ClassScannerABC
from py_to_uxf_core.abc.file_scanner_abc import FileScannerABC
from py_to_uxf_core.abc.python_parser_abc import PythonParserABC
from py_to_uxf_core.model.python_class import PythonClass


class PythonParserService(PythonParserABC):

    def __init__(self, file_scanner: FileScannerABC, class_scanner: ClassScannerABC):
        PythonParserABC.__init__(self)

        self._file_scanner = file_scanner
        self._class_scanner = class_scanner

    def parse(self):
        files = self._file_scanner.scan_files()
        for file in files:
            Console.write_line('f:', file)
            with open(file, 'r') as file_content:
                cls: Optional[PythonClass] = None
                for line in file_content.readlines():
                    if cls is None:
                        cls = self._class_scanner.scan_line_for_classes(line)
                        continue

                    Console.write_line('c:', cls.name)
